<?php if(!defined('PmWiki')) exit();

 /**
 *  Copyright 2011 Carlos A. Bonamigo <cabsec.pmwiki@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **/

/// HTMLCOMPRESS - Replaces action browse and compresses the html output of pmwiki

/// VARIABLES

$RecipeInfo['htmlcompress']['version'] = '20110417';

$HandleActions['browse'] = 'HandleHtmlCompress';
$HandleAuth['browse'] = 'read';

SDV($HtmlCompressTabReturnNewline, array("\t", "\r", "\n"));
SDV($HtmlCompressSpacePat , '/\s{1,10}/');
SDV($HtmlCompressMoreSpace , array(
  "> $KeepToken" => ">$KeepToken",
  "$KeepToken <" => "$KeepToken<",
  "$KeepToken\n" => "$KeepToken",
  "\n$KeepToken" => "$KeepToken",
  "> <style" => "><style",
  "> <table" => "><table",
  "> <meta" => "><meta",
  "> <link" => "><link",
  "<br />" => "<br/>",
  "<hr />" => "<hr/>",
  "> </p>" => "></p>",
  "<p> " => "<p>",
  "> <div" => "><div",
  "> <td" => "><td",
  "> <h1" => "><h1",
  "> <h2" => "><h2",
  "> <h3" => "><h3",
  "> <h4" => "><h4",
  "> <h5" => "><h5",
  "> <h6" => "><h6",
  "--> <" => "--><",
  "<!-- " => "<!--",
  "'> </" => "'></",
  "'> <" => "'><",
  "' />" => "'/>",
  "/> <" => "/><",
  " </" => "</"
));

/// FUNCTIONS

function HtmlCompress($h){
global $HtmlCompressCommentPat,$HtmlCompressTabReturnNewline,
  $HtmlCompressSpacePat,$HtmlCompressMoreSpace,
  $KeepToken;

  // remove one line comments
  $h = preg_replace("/\\<!\\-\\-[\\/A-Za-z]{3,30}\\-\\-\\>/",'', $h);

  // preserve pre and other html tags
  $t = "(textarea|pre|code)";
  $h = preg_replace(
      "/(\\<".$t."[^\>]*\\>.*\\<\\/".$t."\\>)/sUe",
      "Keep(PSS('$1'),'H')", $h);

  // compress in page javascript and preserve
  $h = preg_replace(
      "/(\\<script[^\>]*\\>)(.*)\\<\\/script\\>/sUe",
      "HtmlCompressJs(PSS('$1'),PSS('$2'))", $h);

  // compress in page css and preserve
  $h = preg_replace(
      "/(\\<style[^\>]*\\>)(.*)\\<\\/style\\>/sUe",
      "HtmlCompressCss(PSS('$1'),PSS('$2'))", $h);

  // turn newlines in to spaces inside p tags
  // otherwise words get joined togheter
  $h = preg_replace(
      "/(\\<p[^\>]*\\>.*\\<\\/p\\>)/sUe",
      "str_replace(chr('10'),' ',PSS('$1'))",$h);

  // remove tabs, returns and newlines
  $h = str_replace($HtmlCompressTabReturnNewline,'', $h);

  // replace spaces with just one space
  $h = preg_replace($HtmlCompressSpacePat,' ', $h);

  // more space
  $h = str_replace(array_keys($HtmlCompressMoreSpace),
         array_values($HtmlCompressMoreSpace), $h);

  //restore Keeps
  $h = preg_replace("/$KeepToken(\\d.*?)$KeepToken/e",
          '$GLOBALS[\'KPV\'][\'$1\']',$h);

return $h;
}

function HtmlCompressCss($t,$c){
if(function_exists('CssCompress'))
   $c = CssCompress($c);
$f = $t.$c."</style>";
$f = Keep($f,'C');
return $f;
}

function HtmlCompressJs($t,$j){
if(function_exists('JsCompress'))
   $j = JsCompress($j);
$f = $t.$j."</script>";
$f = Keep($f,'J');
return $f;
}

/// HANDLERS 

function HandleHtmlCompress($pagename,$auth='read'){
  ob_start('HtmlCompress');
  HandleBrowse($pagename,$auth);
  ob_end_flush();
}
